<?php

//Get the current options create empty ones if they don't exist.
$connect_phpbb_options =  get_option('connect_phpbb_options');
if($connect_phpbb_options == ''){
	$connect_phpbb_options = array('path' => '');
}

//Get the paths
if ( !defined('ABSPATH') ){
    define('ABSPATH', (dirname(dirname(dirname(dirname(__FILE__))))) . '/');
}

if(!defined('PHPBBPATH')){
    if($connect_phpbb_options['path'] != ''){
        define('PHPBBPATH',$connect_phpbb_options['path']);
    } else {
        define('PHPBBPATH','forum/');
    }
}

//prepare the paths to the folders and files
$config_files = array(
    'auth_wpbb' => array(
        'source' => dirname(__FILE__).'/files/auth_wpbb.php',
        'destin' => ABSPATH.PHPBBPATH.'includes/auth/auth_wpbb.php',
        'folder' => ABSPATH.PHPBBPATH.'includes/auth'
        ),
    'common' => array(
        'source' => dirname(__FILE__).'/files/common.php',
        'destin' => ABSPATH.PHPBBPATH.'common.php',
        'folder' => ABSPATH.PHPBBPATH
        ),
    'common.orig' => array(
        'destin' => ABSPATH.PHPBBPATH.'common.orig.php',
        )
    );

//function to get the auth modes, copied from phpbb 3.0.6 : /includes/acp_/acp_board.php line 665
function wpbb_select_auth_method($selected_method, $key = '')
{
        $phpbb_root_path = ABSPATH.PHPBBPATH;
        $phpEx = 'php';

        $auth_plugins = array();

        $dp = @opendir($phpbb_root_path . 'includes/auth');

        if (!$dp)
        {
                return '';
        }

        while (($file = readdir($dp)) !== false)
        {
                if (preg_match('#^auth_(.*?)\.' . $phpEx . '$#', $file))
                {
                        $auth_plugins[] = preg_replace('#^auth_(.*?)\.' . $phpEx . '$#', '\1', $file);
                }
        }
        closedir($dp);

        sort($auth_plugins);

        $auth_select = '';
        foreach ($auth_plugins as $method)
        {
                $selected = ($selected_method == $method) ? ' selected="selected"' : '';
                $auth_select .= '<option value="' . $method . '"' . $selected . '>' . ucfirst($method) . '</option>';
        }

        return $auth_select;
}

function wpbb_get_file_version($file)
{
	if(file_exists($file)){
		$content = file_get_contents($file);
		if(strpos($content, '@version $Id: common.php') !== false){
			return "Original";
		}
		preg_match('/@version\s([0-9.]+)/',$content,$version);
		return $version[1];
	} else {
		return 0;
	}
}

function wpbb_get_file_versions()
{
    global $config_files;
    //GETS all the files versions ::
    $file_versions = array(
        'auth_wpbb' => array(
            'source' => wpbb_get_file_version($config_files['auth_wpbb']['source']),
            'destin' => wpbb_get_file_version($config_files['auth_wpbb']['destin'])
            ),
        'common' => array(
            'source' => wpbb_get_file_version($config_files['common']['source']),
            'destin' => wpbb_get_file_version($config_files['common']['destin'])
            ),
        'common.orig' => array(
            'destin' => wpbb_get_file_version($config_files['common.orig']['destin']),
            )
        );
    return $file_versions;
}

function wpbb_get_current_auth_method()
{
    global $wpdb;

    //Get_the phpbb prefix
    $phpbb_db_prefix = wpbb_get_phpbb_prefix();
    $config_table = $phpbb_db_prefix.'config';

    $data = $wpdb->get_var('SELECT config_value FROM '.$config_table.' WHERE config_name = \'auth_method\'', 0, 0);

    return $data;
}

function wpbb_get_phpbb_prefix()
{
    $file = ABSPATH.PHPBBPATH.'config.php';

    if(file_exists($file)){
        $content = file_get_contents($file);

        preg_match('/dbname\s{0,}=\s{0,}[\'"]([0-9A-Za-z_]+)[\'"]/',$content,$dbname);
        preg_match('/table_prefix\s{0,}=\s{0,}[\'"]([0-9A-Za-z_]+)[\'"]/',$content,$table_prefix);

        return $table_prefix[1];
    } else {
        return 0;
    }



    //TODO :: MAKE IT REALLY WORK
    return 'phpbb_';
}

function wpbb_run_test($echo = true)
{
    
    $file_versions = wpbb_get_file_versions();
    $test = array(
        'auth_wpbb.php' => true,
        'common.php' => true,
        'common.orig.php' => true,
        'auth_method' => true,
        'path_var' => true
    );
    $error = false;

    //auth_wpbb.php
    if($file_versions['auth_wpbb']['source'] != $file_versions['auth_wpbb']['destin']){
        $error = true ;
        $test['auth_wpbb.php'] = false;
    }

    //common.php
    if($file_versions['common']['source'] != $file_versions['common']['destin']){
        $error = true ;
        $test['common.php'] = false;
    }

    //common.orig.php
    if($file_versions['common.orig']['destin'] != 'Original'){
        $error = true ;
        $test['common.orig.php'] = false;
    }

    //auth_method
    $auth_method = wpbb_get_current_auth_method();
    if($auth_method != 'wpbb'){
        $error = true;
        $test['auth_method'] = false;
    }

    //path_var
    $path_var = get_option('connect_phpbb_options');
    if(!(isset($path_var['path']) && $path_var['path'] != '')){
        $error = true ;
        $test['path_var'] = false;
    }


    if($echo)
    echo '
      	<table>
            <tr>
                <th width="200">&nbsp;</th>
                <th width="100">Reccomended</th>
                <th width="100">Current</th>
                <th width="50">OK ?</th>
            </tr>
            <tr>
                <th>Files</th>
            </tr>
            <tr>
                <td>auth_wpbb.php</td>
                <td>'.$file_versions['auth_wpbb']['source'].'</td>
                <td>'.$file_versions['auth_wpbb']['destin'].'</td>
                <td>'.wpbb_passed_test($test['auth_wpbb.php']).'</td>
            </tr>
            <tr>
                <td>common.php</td>
                <td>'.$file_versions['common']['source'].'</td>
                <td>'.$file_versions['common']['destin'].'</td>
                <td>'.wpbb_passed_test($test['common.php']).'</td>
            </tr>
            <tr>
                <td>common.orig.php</td>
                <td>-</td>
                <td>'.$file_versions['common.orig']['destin'].'</td>
                <td>'.wpbb_passed_test($test['common.orig.php']).'</td>
            </tr>
            <tr>
                <th>Configurations</th>
            </tr>
            <tr>
                <td>Auth Mode</td>
                <td>wpbb</td>
                <td>'.$auth_method.'</td>
                <td>'.wpbb_passed_test($test['auth_method']).'</td>
            </tr>
            <tr>
                <td>Wordpress Path</td>
                <th><i>Variable</i></th>
                <td>'.$path_var['path'].'</td>
                <td>'.wpbb_passed_test($test['path_var']).'</td>
            </tr>

	</table>';

    return $error;
}

function wpbb_passed_test($test_result){
    if($test_result){
        return '<span style="color:green">OK</span>';
    } else {
        return '<span style="color:red">Error</span>';
    }
}

function wpbb_get_functions_conflict(){
    $functions_list = wpbb_folder_function_list(ABSPATH.PHPBBPATH);
    //print_r($functions_list);
    $modules_directory = str_replace('/phpbb-single-sign-on', '',dirname(__FILE__));
    
    $modules_list = wpbb_get_modules_list($modules_directory);

    foreach($modules_list as $module){
        $list = wpbb_folder_function_list($modules_directory.'/'.$module.'/');

        print_r(array_intersect($list, $functions_list));
        //print_r($list);
    }

}

function wpbb_get_modules_list($modules_directory){
    $modules_list= array();

    $iterator = new DirectoryIterator($modules_directory);
    foreach($iterator as $file) {
        if($file->isDir() && !$file->isDot()){
            $name = $file->getFilename();
            if($name != 'phpbb-single-sign-on'){
                $modules_list[] = $name;
            }
        }
    }
    return $modules_list;
}

function wpbb_folder_function_list($folder){
    $file_list = wpbb_get_files_list($folder);

    $function_list = array();
    foreach($file_list as $file){
            $file_path = $folder.$file;
            $function_list = array_merge($function_list, wpbb_functions_list($file_path));
    }

    $function_list = array_unique($function_list);

    return $function_list;
}

function wpbb_get_files_list($directory, &$list = array(), $base = ''){
    $iterator = new DirectoryIterator($directory);
    foreach($iterator as $file) {

        if(!$file->isDot()) {
            $name = $file->getFilename();

            if($file->isDir() && $name != 'cache') {
                wpbb_get_files_list($directory.'/'.$name, &$list, $base.$name.'/');
            } else {
                if(strpos($name, '.php') !== false && $name != 'auth_wpbb.php' && $name != 'common.orig.php'){
                    $list[] = $base.$name;
                }
            }
        }

    }
    return $list;
}

function wpbb_functions_list($file){
    if(file_exists($file)){
        $content = file_get_contents($file);

        preg_match_all('/function\s{1,}([0-9A-Za-z_\-]+)\s{0,}\(/',$content,$functions);

        if(count($functions != 0)){
            return $functions[1];
        }
    }
    //else
    return array();
}

